: <<canvasE.f>> ;
CR
( sample canvas )
VARIABLE hDC
VARIABLE hMemDC
VARIABLE hCanvas
VARIABLE hBitmap
VARIABLE hOldBitmap
VARIABLE LASTCANVAS
VARIABLE THISCANVAS

\ hMemDC stored in first cell of extra byte 
: MEMDC ( -- hMemDC) hCanvas @ 0 GetWindowLongA ;
\ MEMDC point to current canvas, select current canvas by click the canvas
: SETMEMDC ( hMemDC -- ) >R hCanvas @ 0 R> SetWindowLongA DROP ;

\ oldBitmap (1x1 b/w) stored in second cell of extra byte
: OLDBITMAP ( -- hBitmap ) hCanvas @ 4 GetWindowLongA ;
: SETOLDBITMAP ( hBitmap -- ) >R hCanvas @ 4 R> SetWindowLongA DROP ;

CREATE PAINTSTRUCT $40 ALLOT
(   HDC  hdc; 
    BOOL fErase; 
    RECT rcPaint; 
    BOOL fRestore; 
    BOOL fIncUpdate; 
    BYTE rgbReserved[32]; )

: FREEMEMDC
  MEMDC DUP OLDBITMAP SelectObject    \ unselect the bitmap
  DeleteObject DROP               \ delete the bitmap
  DeleteDC DROP
;
: update
  hCanvas @ RECT GetClientRect DROP
  hCanvas @ RECT 0 InvalidateRect DROP
;

: clearcanvas
  MEMDC WHITE_BRUSH GetStockObject SelectObject DROP
  MEMDC 0 0 RECT.RIGHT @ RECT.BOTTOM @ Rectangle DROP
  update
;
: CREATEMEMDC ( -- )
  hCanvas @ RECT GetClientRect DROP
  hCanvas @ GetDC hDC !
  hDC @ CreateCompatibleDC  SETMEMDC 
  hDC @ RECT.RIGHT @ RECT.BOTTOM @ CreateCompatibleBitmap  hBitmap !
  MEMDC hBitmap @ SelectObject  SETOLDBITMAP
  hCanvas @ hDC @ ReleaseDC DROP
  MEMDC 7 GetStockObject SelectObject DROP
  clearcanvas
;

: CANVASONCREATE
  CREATEMEMDC
;

VARIABLE (MOUSEMOVE)
VARIABLE (LBUTTONDOWN)
VARIABLE (LBUTTONUP)
VARIABLE (LBUTTONDBLCLK)
VARIABLE (RBUTTONDOWN)
VARIABLE (RBUTTONUP)
VARIABLE (RBUTTONDBLCLK)
VARIABLE mouse_x
VARIABLE mouse_y

: CANVASPROC ( hCanvas uMsg wParam lParam -- res )
  GETMSGWLPARAM hCanvas !
  MEMDC THISCANVAS !
  uMsg @ WM_PAINT = IF
      hCanvas @ PAINTSTRUCT BeginPaint hDC !
      hCanvas @ RECT GetClientRect DROP 
      hDC @ 0 0 RECT.RIGHT RECT.BOTTOM MEMDC 0 0 SRCCOPY BitBlt DROP
      hCanvas @ PAINTSTRUCT EndPaint DROP
      0 EXIT
      
  THEN

  lParam @ GETMOUSEPOS    \ get mousepos.x and .y

  uMsg @ WM_MOUSEMOVE  = IF
    wParam @ DUP IF DUP
      ." flag:" . \ show the flag, 1=left button , 2 right button
\ 4=shift key, 8 = control key
     ." (" MOUSEPOS.X .  ." ," MOUSEPOS.Y . mouse_x ? mouse_y ? ." )" 
       DUP 9 = IF (RBUTTONDBLCLK) @EXECUTE
       ELSE (MOUSEMOVE) @EXECUTE
       THEN CR
    ELSE DROP THEN
  THEN

  uMsg @ WM_LBUTTONDBLCLK  = IF
     (LBUTTONDBLCLK) @EXECUTE
     hCanvas @ Z" left button double click"  SetWindowTextA DROP 
  THEN
  uMsg @ WM_RBUTTONDBLCLK  = IF
     (RBUTTONDBLCLK) @EXECUTE
     hCanvas @ Z" right button double click"  SetWindowTextA DROP 
  THEN
  uMsg @ WM_RBUTTONDOWN  = IF
     (RBUTTONDOWN) @EXECUTE
     hCanvas @ Z" right button down"  SetWindowTextA DROP 
  THEN
  uMsg @ WM_LBUTTONUP  = IF
     (LBUTTONUP) @EXECUTE
     hCanvas @ Z" left button up"  SetWindowTextA DROP 
  THEN
  uMsg @ WM_RBUTTONUP  = IF
     (RBUTTONUP) @EXECUTE
     hCanvas @ Z" right button up"  SetWindowTextA DROP 
  THEN
  uMsg @ WM_LBUTTONDOWN  = IF
     (LBUTTONDOWN) @EXECUTE
     hCanvas @ Z" left button down"  SetWindowTextA DROP 
  THEN

  uMsg @ WM_DESTROY = IF
    FREEMEMDC
    hCanvas @ REMOVEFROMLINK
  THEN
  
  hCanvas @ uMsg @ wParam @ lParam @ DefWindowProcA 
;

' CANVASPROC MESSAGEHANDLER: &CANVASPROC

: createCanvas ( x y w h -- hCanvas ) >r >r >r >r
  0 
  Z" WeForm" 
  Z" Canvas"                                 \ filename  as caption
  $10F80000
\ $0 0 $200 $300      \ width = $100 , height= $100
  r> r> r> r>
  0
  0
  HINST @
  0
  CreateWindowExA dup hCanvas ! >R
  
  R@ LASTCANVAS INSERTTOLINK CANVASONCREATE
  R@ GWL_WNDPROC &CANVASPROC SetWindowLongA DROP
  R@ WM_SIZE 0 0 SendMessageA DROP R> ;

: newcanvas ( -- ) 0 0 $317 $230 createCanvas drop ;

exit

: circle 
  MEMDC GRAY_BRUSH GetStockObject SelectObject DROP
  >R >R >R >R
  MEMDC R> R> R> R> Ellipse DROP
;


: rectangle ( x y w h -- )
  MEMDC GRAY_BRUSH GetStockObject SelectObject DROP
  >R >R >R >R
  MEMDC R> R> R> R> Rectangle DROP
;

: testdraw 
  10 10 20 20 circle
  10 10 30 30 circle
  10 10 40 40 circle
  10 10 50 50 circle
  10 10 60 60 circle
  update
;
